Const gw = 800, gh = 600;Graphics Constants; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Rabbit Snowboarding;;;;;;;;;;;;;;;;;;;;;;;;
Graphics gw,gh;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;By TNTCoder;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SetBuffer(BackBuffer());;;;;;;;;;;;;;;;;;;;;
;For Wednesday Workshop XXIV ;;;;;;;;;;;;;;; 
SeedRnd(MilliSecs());;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
AppTitle "Rabbit Snowboarding - By TNTcoder"
FrameTime = CreateTimer(60)
;;key codes
Const enterk = 28
;;IMAGES
Global snowimage = LoadImage("snowsmall.jpg")
Global rabbitimage = LoadImage("rabbit.png") : MaskImage(rabbitimage,255,0,255) 
	Global rabbit_width = ImageWidth(rabbitimage)
	Global rabbit_height = ImageHeight(rabbitimage)
Global treeimage = LoadImage("tree.png") : MaskImage(treeimage,255,0,255)
Global carrotimage = LoadImage("carrot.png") : MaskImage carrotimage,255,0,255
Global turboimage = LoadImage("turbo.png") : MaskImage turboimage,255,0,255
Global menu = LoadImage("title screen.png") : MaskImage menu,255,0,255
;;VARIABLES
Global speed# = 5
Global snow_y
Global rabbit_x# = 400,rabbit_y#
Global ttimer ;;tree timer
Global ctimer ;;carrot timer
Global tutimer ;;turbo timer
Global treehit = 0
Global score# = 0
Global rs = 4
;;timer
Global timerstart
Global timer
Global deciseconds
Global seconds
Global minutes
Global time$ = minutes + ":" + seconds + ":" + deciseconds  
;;music
Global music = PlayMusic("everywhere.mod") : PauseChannel music

;;TYPES
Type flake
	Field x#,y#, xv#,yv#, w,h
	Field life
End Type

Type tree
	Field x#,y#
End Type 

Type carrot
	Field x#,y#
End Type

Type turbo
	Field x#,y#
End Type

Delay 2000
.menu
FlushKeys()
SetBuffer FrontBuffer()
Repeat 
	DrawImage(menu,0,0)
	Delay 10
	If KeyDown(1) Then End
Until KeyHit(enterk)
Cls: ResumeChannel music
Countdown

SetBuffer(BackBuffer())
 
timerstart = MilliSecs()
;;MAIN LOOP;;;;;;;;;
Repeat
	UpdateGame()
	RenderImages()
	DrawHUD()
	If KeyHit(1) Then End
	If timer <= 0 Then Exit
	WaitTimer(FrameTime)
	Flip
Forever 
;;END LOOP;;;;;;;;;;
TellScore()
FlushKeys()
Repeat Until KeyHit(54) : ResetEverything()
music = PlayMusic("everywhere.mod") : PauseChannel music 
Goto menu 

;;;Arrow Functions;;;;;;;;;;
Function Upk();;;;;;;;;;;;;;
	Return KeyDown(200);;;;;
End Function;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Function Downk();;;;;;;;;;;;
	Return KeyDown(208);;;;;
End Function;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Function Leftk();;;;;;;;;;;;
	Return KeyDown(203);;;;;
End Function;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Function Rightk();;;;;;;;;;;
	Return KeyDown(205);;;;;
End Function;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;OTHER FUNCTIONS;;;;;;;
Function RenderImages()
	TileBlock snowimage,0,snow_y
	UpdateParticles()
	DrawBackTrees()
	DrawImage rabbitimage,rabbit_x,rabbit_y
	UpdatePickups()
	DrawFrontTrees()
End Function

Function UpdateGame()
	If treehit=True Then speed = 0 : rs=4
	If treehit=False And speed<8 Then speed = speed + 0.1
	snow_y = snow_y - speed ;;move forward
	
	;;;Player's coordinates
	rabbit_x = rabbit_x + (Rightk() - Leftk())*rs
	;rabbit_y = rabbit_y - (Upk() - Downk())*3
	If upk() Then rabbit_y = rabbit_y - rs
	If downk() And treehit=False Then rabbit_y = rabbit_y + rs
	If rabbit_x < 0 Then rabbit_x = 0
	If rabbit_x > gw-rabbit_width Then rabbit_x = gw-rabbit_width
	If rabbit_y < 0 Then rabbit_y = 0
	If rabbit_y > gh-rabbit_height Then rabbit_y = gh-rabbit_height
	;;;End player coordinates update
	
	UpdateTrees()
End Function

Function UpdateParticles()
	Local numflakes = 0
	For f.flake = Each flake
		Color 210,240,245
		f\x = f\x + f\xv : f\y = f\y + f\yv
		Oval f\x,f\y,f\w,f\h,1
		f\life = f\life - 1 
		If f\life = 0 Then Delete f
		numflakes = numflakes + 1
	Next
	
	If treehit=False Then CreateFlake()
End Function

Function CreateFlake()
	f.flake = New flake
	f\x = rabbit_x+90 : f\y = rabbit_y+50
	f\xv = Rnd#(-2,2) : f\yv = Rnd#(-3,-1)
	f\w = Rand(2,6) : f\h = Rand(2,6)
	f\life = Rand(10,60)
End Function

Function UpdateTrees()
	Local numtrees = 0
	treehit = 0
	For t.tree = Each tree
		t\y = t\y - speed
		If ImagesCollide(rabbitimage,rabbit_x,rabbit_y,0,treeimage,t\x,t\y,0) And rabbit_y < t\y Then treehit = treehit+1
		If t\y+ImageHeight(treeimage) < 0 Then Delete t
		numtrees = numtrees + 1
	Next
	
	If numtrees < 10 Then CreateTree()
End Function

Function CreateTree()
	If MilliSecs() > ttimer + 600 Then
		ttimer = MilliSecs()
		t.tree = New tree
		t\x = Rand(10,800-ImageWidth(treeimage))
		t\y = 600+ImageHeight(treeimage)
	EndIf
End Function
;;Z-ordering stuff;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Function DrawBackTrees()                                               ;
	For t.tree = Each tree;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		If t\y < rabbit_y Then DrawImage(treeimage,t\x,t\y)            ;
	Next;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
End Function                                                           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Function DrawFrontTrees()                                              ;
	For t.tree = Each tree;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		If t\y >= rabbit_y Then DrawImage(treeimage,t\x,t\y)           ;
	Next;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
End Function                                                           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Function DrawHUD() ;Draws AND updates the HUD
	score = score + speed/200
	
	Color 255,255,255
	Rect gw-100,0,100,30,1
	
	Color 0,0,0
	Text gw-95,5,"Score: " + Int(score)
	UpdateTimer()
	Text gw-95,15,"Time: " + time 
End Function 

Function UpdateTimer()
	timer = MilliSecs() - timerstart
	timer = 60000 - timer
	deciseconds = timer/100
	seconds = timer/1000 
	minutes = timer/60000
	If deciseconds > 9 Then
		deciseconds = deciseconds - (seconds*10)
	EndIf 
	If seconds > 59 Then
		seconds = seconds - (seconds*10) 
	EndIf
	
	If seconds<10 ;if less than 10 seconds have passed  
		time = minutes + ":" + "0" + seconds + ":" + deciseconds ;print a 0 before the number of seconds
	Else
		time = minutes + ":" + seconds + ":" + deciseconds ;don't print the zero
	EndIf 
End Function 

Function TellScore()
	FlushKeys() : SetBuffer(FrontBuffer())
	Delay 800
	FlushKeys()
	ClsColor 255,255,255 : Cls : Color 0,0,0
	Text gw/2,gh/2,"Time's Up",1,1
	Text gw/2,(gh/2)+15,"Your Score: " + Int(score),1,1
	Text gw/2,(gh/2)+30,"Press Shift to Return to main menu",1,1
End Function

Function UpdatePickups()
	Local numcarrots = 0
	For c.carrot = Each carrot
		c\y = c\y - speed
		
		
		DrawImage carrotimage,c\x,c\y
		
		If c\y+ImageHeight(carrotimage) < 0 Then Delete c : Exit 
		If ImagesCollide(rabbitimage,rabbit_x,rabbit_y,0,carrotimage,c\x,c\y,0)
			Delete c
			score = score + 25
		EndIf
		
		numcarrots = numcarrots + 1
	Next
	
 	If numcarrots < 7 Then CreateCarrot()
	
	Local numturbos = 0
	For t.turbo = Each turbo
		t\y = t\y - speed
		DrawImage turboimage,t\x,t\y
		
		If t\y+ImageHeight(turboimage) < 0 Then Delete t : Exit 
		
		If ImagesCollide(rabbitimage,rabbit_x,rabbit_y,0,turboimage,t\x,t\y,0)
			Delete t
			score = score + 10
			speed = 14 : rs = 6
		EndIf
		numturbos = numturbos + 1
	Next
	
	If numturbos < 1 Then CreateTurbo()
End Function

Function CreateCarrot()
	If MilliSecs() > ctimer + 600 Then
		ctimer = MilliSecs()
		c.carrot = New carrot
		c\x = Rand(10,800-ImageWidth(carrotimage))
		c\y = 600+ImageHeight(carrotimage)
	EndIf
End Function

Function CreateTurbo()
	If MilliSecs() > tutimer + 600 Then
		tutimer = MilliSecs()
		t.turbo = New turbo
		t\x = Rand(10,800-ImageWidth(turboimage))
		t\y = 600+ImageHeight(turboimage)
	EndIf
End Function

Function ResetEverything()
	Delete Each tree
	Delete Each turbo
	Delete Each carrot
	Delete Each flake
	
	speed# = 5
	rabbit_x# = 400 : rabbit_y# = 0
	treehit = 0
	score# = 0
	rs = 4

End Function 

Function Countdown()
	Print "Game Starts in..."
	For count = 3 To 1 Step -1
		
		Print count
		Delay 1000
	Next
End Function 